'===============================================================================
' Two Windows.bas
' Created on October 13, 2023
'
' See the following post by dodicat in freebasic.net: 
' Re: InputBox() in console program
' Post by dodicat » Jul 15, 2019 13:22
' https://www.freebasic.net/forum/viewtopic.php?t=27725
'
'===============================================================================

'This program shows a simple window (Mainwindow) with a button. When the button
'is clicked, a second window (InputWindow) will open, and the text entered into
'the input window will be displayed in a messagebox.
'
'Two windows can use the same registered window class and the same callback
'function (WndProc).  

#Include "WinLib.bi"

Dim Shared As HWND  MainWindow, InputWindow
Dim Shared As HWND Text_txt, Button1, Button2


Sub CreateInputWindow

	InputWindow = Window_New("WindowClass", CW_USEDEFAULT, CW_USEDEFAULT, 250, 150, "InputWindow", WS_OVERLAPPED Or WS_SYSMENU Or WS_VISIBLE)
	Var Label_txt = Label_New	(10, 20, 200, 20, "Enter a text here:",, InputWindow)
	Text_txt = TextBox_New		(10, 50, 200, 20, "",, InputWindow)
	Button2 = Button_New			(10, 80, 200, 20, "Ok",, InputWindow)
	
End Sub 


Function WndProc(hWnd As HWND, message As UINT, wParam As WPARAM, lParam As LPARAM) As LRESULT

	Dim As String text
	
  Select Case hWnd
    
    Case MainWindow 
     
      Select Case message
      
				Case WM_COMMAND
				
					Select Case lParam  
						Case Button1 
							CreateInputWindow 
					End Select
					
			  Case WM_CLOSE
			  
           PostQuitMessage(0)
           
      End Select 
        
    Case InputWindow
      
      Select Case message
      
        Case WM_COMMAND
        
          Select Case lParam
            Case Button2
							text = TextBox_GetText(Text_txt)
              MessageBox(InputWindow, text, "This is your text:", 0)
          End Select
            
        Case WM_CLOSE
        
					DestroyWindow(InputWindow)
            
      End Select
       
    End Select
    
    Return DefWindowProc(hWnd, message, wParam, lParam)
    
End Function


RegisterWindowClass("WindowClass", @WndProc)
MainWindow = Window_New("WindowClass", 10, 10, 500, 500, "MainWindow")
Var Label1 = Label_New(50, 100, 300, 40, _
	"This is the mainwindow. " & Chr(13, 10) & _
	"Click the button to open a second window!",, _
	MainWindow)
Button1 = Button_New(50, 200, 100, 20, "Click me!",, MainWindow)
RunMessageLoop

End

